/*----- PROTECTED REGION ID(Socket2Client.h) ENABLED START -----*/
//=============================================================================
//
// file :        Socket2Client.h
//
// description : Include file for the Socket2Client class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.4 $
// $Date: 2018-01-08 10:32:23 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Socket2Client_H
#define Socket2Client_H

#include <tango.h>


/*----- PROTECTED REGION END -----*/	//	Socket2Client.h

/**
 *  Socket2Client class description:
 *    
 */

namespace Socket2Client_ns
{
/*----- PROTECTED REGION ID(Socket2Client::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	Socket2Client::Additional Class Declarations

class Socket2Client : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(Socket2Client::Data Members) ENABLED START -----*/

//	Add your own data members
private:
	Tango::DeviceProxy *device_proxy;
	string init_error;

/*----- PROTECTED REGION END -----*/	//	Socket2Client::Data Members

//	Device property data members
public:
	//	DeviceName:	
	string	deviceName;

	bool	mandatoryNotDefined;


//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Socket2Client(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Socket2Client(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Socket2Client(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~Socket2Client() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : Socket2Client::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);


	//--------------------------------------------------------
	/**
	 *	Method      : Socket2Client::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:


	//--------------------------------------------------------
	/**
	 *	Method      : Socket2Client::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(Socket2Client::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes
private:
	void check_init();
	void write_(const vector<unsigned char> &data_to_write);
	void read_(const Tango::DevLong len, vector<unsigned char> &data_to_read);
	void read_until_(const unsigned char delim, vector<unsigned char> &data_to_read);

protected:
	int input_length();
	int output_length();

	// Methods for binary protocols (using std::vector<char>)
	void write(const vector<unsigned char> &data_to_write);
	void read(const Tango::DevLong len, vector<unsigned char> &data_to_read);
	void read_until(const unsigned char delim, vector<unsigned char> &data_to_read);

	// Methods for ascii protocols (using std::string)
	void write(const string &data_to_write);
	void read(const Tango::DevLong len, string &data_readed);
	void read_until(const char delim, string &data_readed);

	Tango::DevState get_state2();
	string get_status2();

	// Methods for binary protocols (using Tango::DevVarCharArray)

//	void write(const Tango::DevVarCharArray *data_to_write);

/*
	void write(const Tango::DevString *data_to_write);

*/
/*	void read(Tango::DeviceProxy &dp, const Tango::DevLong len,
			Tango::DevVarCharArray &data_readed);

	void read_until(Tango::DeviceProxy &dp,	const Tango::DevVarCharArray &delim,
			Tango::DevVarCharArray &data_readed);
*/
/*
	void write_and_read(Tango::DeviceProxy &dp, const Tango::DevVarCharArray &data_to_write,
			const Tango::DevLong len, Tango::DevVarCharArray &data_readed);

	void write_and_read_until(Tango::DeviceProxy &dp,
			const Tango::DevVarCharArray &data_to_write, 
			const Tango::DevVarCharArray &delim,
			Tango::DevVarCharArray &data_readed);
*/
	// Methods for ascii protocols (using Tango::DevString)
/*	void write_and_read(Tango::DeviceProxy &dp, const string &data_to_write,
			const Tango::DevLong len, string &data_readed);

	void write_and_read_until(Tango::DeviceProxy &dp, const string &data_to_write,
			const string &delim, string &data_readed);
*/

	string dump_ascii(const vector<unsigned char> &data);
	string dump_hex(const vector<unsigned char> &data);

/*----- PROTECTED REGION END -----*/	//	Socket2Client::Additional Method prototypes
};

/*----- PROTECTED REGION ID(Socket2Client::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	Socket2Client::Additional Classes Definitions

}	//	End of namespace

#endif   //	Socket2Client_H
